/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.workresignationtemplate.web;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.ConstraintViolationException;

import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

import com.google.common.collect.Lists;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.MyBeanUtils;
import com.jeeplus.common.config.Global;
import com.jeeplus.common.persistence.Page;
import com.jeeplus.common.web.BaseController;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.common.utils.excel.ExportExcel;
import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.modules.workresignationtemplate.entity.WorkResignationTemplate;
import com.jeeplus.modules.workresignationtemplate.service.WorkResignationTemplateService;

/**
 * 离职审核列表Controller
 * @author lw
 * @version 2018-08-07
 */
@Controller
@RequestMapping(value = "${adminPath}/workresignationtemplate/workResignationTemplate")
public class WorkResignationTemplateController extends BaseController {

	@Autowired
	private WorkResignationTemplateService workResignationTemplateService;
	
	@ModelAttribute
	public WorkResignationTemplate get(@RequestParam(required=false) String id) {
		WorkResignationTemplate entity = null;
		if (StringUtils.isNotBlank(id)){
			entity = workResignationTemplateService.get(id);
		}
		if (entity == null){
			entity = new WorkResignationTemplate();
		}
		return entity;
	}
	
	/**
	 * 离职审核列表列表页面
	 */
	@RequiresPermissions("workresignationtemplate:workResignationTemplate:list")
	@RequestMapping(value = {"list", ""})
	public String list(WorkResignationTemplate workResignationTemplate, HttpServletRequest request, HttpServletResponse response, Model model) {
		Page<WorkResignationTemplate> page = workResignationTemplateService.findPage(new Page<WorkResignationTemplate>(request, response), workResignationTemplate); 
		model.addAttribute("page", page);
		return "modules/workresignationtemplate/workResignationTemplateList";
	}

	/**
	 * 查看，增加，编辑离职审核列表表单页面
	 */
	@RequiresPermissions(value={"workresignationtemplate:workResignationTemplate:view","workresignationtemplate:workResignationTemplate:add","workresignationtemplate:workResignationTemplate:edit"},logical=Logical.OR)
	@RequestMapping(value = "form")
	public String form(WorkResignationTemplate workResignationTemplate, Model model) {
		model.addAttribute("workResignationTemplate", workResignationTemplate);
		return "modules/workresignationtemplate/workResignationTemplateForm";
	}

	/**
	 * 保存离职审核列表
	 */
	@RequiresPermissions(value={"workresignationtemplate:workResignationTemplate:add","workresignationtemplate:workResignationTemplate:edit"},logical=Logical.OR)
	@RequestMapping(value = "save")
	public String save(WorkResignationTemplate workResignationTemplate, Model model, RedirectAttributes redirectAttributes) throws Exception{
		if (!beanValidator(model, workResignationTemplate)){
			return form(workResignationTemplate, model);
		}
		if(!workResignationTemplate.getIsNewRecord()){//编辑表单保存
			WorkResignationTemplate t = workResignationTemplateService.get(workResignationTemplate.getId());//从数据库取出记录的值
			MyBeanUtils.copyBeanNotNull2Bean(workResignationTemplate, t);//将编辑表单中的非NULL值覆盖数据库记录中的值
			workResignationTemplateService.save(t);//保存
		}else{//新增表单保存
			workResignationTemplateService.save(workResignationTemplate);//保存
		}
		addMessage(redirectAttributes, "保存离职审核列表成功");
		return "redirect:"+Global.getAdminPath()+"/workresignationtemplate/workResignationTemplate/?repage";
	}
	
	/**
	 * 删除离职审核列表
	 */
	@RequiresPermissions("workresignationtemplate:workResignationTemplate:del")
	@RequestMapping(value = "delete")
	public String delete(WorkResignationTemplate workResignationTemplate, RedirectAttributes redirectAttributes) {
		workResignationTemplateService.delete(workResignationTemplate);
		addMessage(redirectAttributes, "删除离职审核列表成功");
		return "redirect:"+Global.getAdminPath()+"/workresignationtemplate/workResignationTemplate/?repage";
	}
	
	/**
	 * 批量删除离职审核列表
	 */
	@RequiresPermissions("workresignationtemplate:workResignationTemplate:del")
	@RequestMapping(value = "deleteAll")
	public String deleteAll(String ids, RedirectAttributes redirectAttributes) {
		String idArray[] =ids.split(",");
		for(String id : idArray){
			workResignationTemplateService.delete(workResignationTemplateService.get(id));
		}
		addMessage(redirectAttributes, "删除离职审核列表成功");
		return "redirect:"+Global.getAdminPath()+"/workresignationtemplate/workResignationTemplate/?repage";
	}
	
	/**
	 * 导出excel文件
	 */
	@RequiresPermissions("workresignationtemplate:workResignationTemplate:export")
    @RequestMapping(value = "export", method=RequestMethod.POST)
    public String exportFile(WorkResignationTemplate workResignationTemplate, HttpServletRequest request, HttpServletResponse response, RedirectAttributes redirectAttributes) {
		try {
            String fileName = "离职审核列表"+DateUtils.getDate("yyyyMMddHHmmss")+".xlsx";
            Page<WorkResignationTemplate> page = workResignationTemplateService.findPage(new Page<WorkResignationTemplate>(request, response, -1), workResignationTemplate);
    		new ExportExcel("离职审核列表", WorkResignationTemplate.class).setDataList(page.getList()).write(response, fileName).dispose();
    		return null;
		} catch (Exception e) {
			addMessage(redirectAttributes, "导出离职审核列表记录失败！失败信息："+e.getMessage());
		}
		return "redirect:"+Global.getAdminPath()+"/workresignationtemplate/workResignationTemplate/?repage";
    }

	/**
	 * 导入Excel数据

	 */
	@RequiresPermissions("workresignationtemplate:workResignationTemplate:import")
    @RequestMapping(value = "import", method=RequestMethod.POST)
    public String importFile(MultipartFile file, RedirectAttributes redirectAttributes) {
		try {
			int successNum = 0;
			int failureNum = 0;
			StringBuilder failureMsg = new StringBuilder();
			ImportExcel ei = new ImportExcel(file, 1, 0);
			List<WorkResignationTemplate> list = ei.getDataList(WorkResignationTemplate.class);
			for (WorkResignationTemplate workResignationTemplate : list){
				try{
					workResignationTemplateService.save(workResignationTemplate);
					successNum++;
				}catch(ConstraintViolationException ex){
					failureNum++;
				}catch (Exception ex) {
					failureNum++;
				}
			}
			if (failureNum>0){
				failureMsg.insert(0, "，失败 "+failureNum+" 条离职审核列表记录。");
			}
			addMessage(redirectAttributes, "已成功导入 "+successNum+" 条离职审核列表记录"+failureMsg);
		} catch (Exception e) {
			addMessage(redirectAttributes, "导入离职审核列表失败！失败信息："+e.getMessage());
		}
		return "redirect:"+Global.getAdminPath()+"/workresignationtemplate/workResignationTemplate/?repage";
    }
	
	/**
	 * 下载导入离职审核列表数据模板
	 */
	@RequiresPermissions("workresignationtemplate:workResignationTemplate:import")
    @RequestMapping(value = "import/template")
    public String importFileTemplate(HttpServletResponse response, RedirectAttributes redirectAttributes) {
		try {
            String fileName = "离职审核列表数据导入模板.xlsx";
    		List<WorkResignationTemplate> list = Lists.newArrayList(); 
    		new ExportExcel("离职审核列表数据", WorkResignationTemplate.class, 1).setDataList(list).write(response, fileName).dispose();
    		return null;
		} catch (Exception e) {
			addMessage(redirectAttributes, "导入模板下载失败！失败信息："+e.getMessage());
		}
		return "redirect:"+Global.getAdminPath()+"/workresignationtemplate/workResignationTemplate/?repage";
    }
	
	
	

}